
import bpy
from bpy.types import Menu, Operator

class Scale_Apply(bpy.types.Operator):
    bl_idname = "scale.apply"
    bl_label = "Scale"

    def execute(self, context):
        bpy.ops.object.transform_apply(scale=True)
        return {'FINISHED'}
    
class Rotation_Apply(bpy.types.Operator):
    bl_idname = "rotation.apply"
    bl_label = "Rotation"

    def execute(self, context):
        bpy.ops.object.transform_apply(rotation=True)
        return {'FINISHED'}
    
class Location_Apply(bpy.types.Operator):
    bl_idname = "location.apply"
    bl_label = "Location"

    def execute(self, context):
        bpy.ops.object.transform_apply(location=True)
        return {'FINISHED'}
    
    
class ScaleAndRotation_Apply(bpy.types.Operator):
    bl_idname = "scaleandrotation.apply"
    bl_label = "Rotaion & Scale"

    def execute(self, context):
        bpy.ops.object.transform_apply(rotation=True, scale=True)
        return {'FINISHED'}
    
class OBJECT_MT_PIE_Applydatapie(Menu):
    bl_label = "Apply"

    def draw(self, context):
        layout = self.layout

        pie = layout.menu_pie()
        pie.operator("Scale.apply")
        pie.operator("Rotation.apply")
        pie.operator("Location.apply")
        pie.operator("Scaleandrotation.apply")


global_addon_keymaps = []



def register():
    bpy.utils.register_class(OBJECT_MT_PIE_Applydatapie)
    bpy.utils.register_class(Scale_Apply)
    bpy.utils.register_class(Rotation_Apply)
    bpy.utils.register_class(Location_Apply)
    bpy.utils.register_class(ScaleAndRotation_Apply)
    
    window_manager = bpy.context.window_manager
    if window_manager.keyconfigs.addon:

        keymap = window_manager.keyconfigs.addon.keymaps.new(name='3D View', space_type = 'VIEW_3D')
        
        keymap_item = keymap.keymap_items.new('wm.call_menu_pie', 'T', 'PRESS', ctrl=True,)
        keymap_item.properties.name = "OBJECT_MT_PIE_Applydatapie"


        global_addon_keymaps.append((keymap, keymap_item))
        
def unregister():
    bpy.utils.unregister_class(OBJECT_MT_PIE_Applydatapie)
    bpy.utils.unregister_class(Scale_Apply)
    bpy.utils.unregister_class(Rotation_Apply)
    bpy.utils.unregister_class(Location_Apply)
    bpy.utils.unregister_class(ScaleAndRotation_Apply)
    
    window_manager = bpy.context.window_manager
    if window_manager and window_manager.keyconfigs and window_manager.keyconfigs.addon:
        
        for keymap, keymap_item in global_addon_keymaps:
            keymap.keymap_items.remove(keymap_item)

    global_addon_keymaps.clear()


if __name__ == "__main__":
    register()

    bpy.ops.wm.call_menu_pie(name="OBJECT_MT_PIE_Applydatapie") 
    