import bpy
from bpy.types import Menu, Operator

class Eevee_Engine(bpy.types.Operator):
    bl_idname = "eevee.engine"
    bl_label = "EEVEE"

    def execute(self, context):
        bpy.context.scene.render.engine = 'BLENDER_EEVEE'
        return {'FINISHED'}
    
class Cycles_Engine(bpy.types.Operator):
    bl_idname = "cycles.engine"
    bl_label = "Cycles"

    def execute(self, context):
        bpy.context.scene.render.engine = 'CYCLES'
        return {'FINISHED'}
    
class Workbench_Engine(bpy.types.Operator):
    bl_idname = "workbench.engine"
    bl_label = "Workbench"

    def execute(self, context):
        bpy.context.scene.render.engine = 'BLENDER_WORKBENCH'
        return {'FINISHED'}



class VIEW3D_MT_PIE_RenderEnginepie(Menu):
    bl_label = "Render Engine"

    def draw(self, context):
        layout = self.layout

        pie = layout.menu_pie()
        pie.operator("EEVEE.engine", icon="MEMORY")
        pie.operator("CYCLES.engine", icon="MEMORY")
        pie.operator("WORKBENCH.engine", icon="MEMORY")


global_addon_keymaps = []



def register():
    bpy.utils.register_class(VIEW3D_MT_PIE_RenderEnginepie)
    bpy.utils.register_class(Eevee_Engine)
    bpy.utils.register_class(Cycles_Engine)
    bpy.utils.register_class(Workbench_Engine)
    #keymap
    window_manager = bpy.context.window_manager
    if window_manager.keyconfigs.addon:
        keymap = window_manager.keyconfigs.addon.keymaps.new(name='3D View', space_type='VIEW_3D')
        keymap_item = keymap.keymap_items.new('wm.call_menu_pie', 'T', 'PRESS', shift=True)
        keymap_item.properties.name = "VIEW3D_MT_PIE_RenderEnginepie"
        global_addon_keymaps.append((keymap, keymap_item))
    
        
def unregister():
    bpy.utils.unregister_class(VIEW3D_MT_PIE_RenderEnginepie)
    bpy.utils.unregister_class(Eevee_Engine)
    bpy.utils.unregister_class(Cycles_Engine)
    bpy.utils.unregister_class(Workbench_Engine)
    #keymap
    window_manager = bpy.context.window_manager
    if window_manager and window_manager.keyconfigs and window_manager.keyconfigs.addon:
        for keymap, keymap_item in global_addon_keymaps:
            keymap.keymap_items.remove(keymap_item)
    global_addon_keymaps.clear()
    
if __name__ == "__main__":
    register()

    bpy.ops.wm.call_menu_pie(name="VIEW3D_MT_PIE_RenderEnginepie")